// :: Part of RegionCreator
// Author: Sunshine

#pragma once

#include <windows.h>
#include <olectl.h>
#include <ole2.h>

class CImageFile
{
private:
	LPSTR				filename;
	HBITMAP				hBitmap;

public:
	// ** constructor
	CImageFile();
	// ** destructor
	~CImageFile();

	// ** Load a bitmap and fill all buffer
	bool Load(LPSTR filename);

	// ** draw bitmap
	bool Draw(HDC hdc, int x, int y);

	// ** draw part of bitmap
	bool DrawEx(HDC hdc, int x_dest, int y_dest,
				int x_source, int y_source);
	// ** draw part of bitmap zoomed
	bool DrawExZoom(HDC hdc, int destX, int destY, int destWidth, int destHeight,
				int x_source, int y_source, float zoom = 1.0f);

	// ** check if there is a bitmap loaded
	bool bFileLoaded;

	HBITMAP getBitmap() { return hBitmap; }

	// ** get height of bitmap
	int getHeight();

	// ** get width of bitmap
	int getWidth();

};