// :: Part of RegionCreator
// Author: Sunshine

#include "CSunRegion.h"

CSunRegion::CSunRegion(HWND hwnd)
{
	this->hwnd = hwnd;
}

CSunRegion::~CSunRegion()
{
}


BOOL CSunRegion::LoadFromFile(LPSTR filename)
{
	// create file
	HANDLE hFile = CreateFile(filename, GENERIC_READ,
						FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
	if (hFile == INVALID_HANDLE_VALUE)
	{
		return FALSE;
	}

	// read file
	int iSize = GetFileSize(hFile, NULL);
	LPRGNDATA pData = new RGNDATA[iSize];

	DWORD bw;
	if ( !(ReadFile(hFile, pData, iSize, &bw, NULL)) || (bw != iSize) )
	{
		return FALSE;
	}

	// get the region from  binary data
	HRGN hRegion = ExtCreateRegion(NULL, iSize, pData);
	SetWindowRgn( hwnd, hRegion, FALSE );

	return TRUE;
}

BOOL CSunRegion::LoadFromRes(LPCTSTR lpName, LPCTSTR lpType)
{
	// find resource
	HRSRC hrSkin = FindResource(GetModuleHandle(0), MAKEINTRESOURCE(lpName),lpType);
	if (!hrSkin) return FALSE;

	// load resource in a buffer
	LPRGNDATA pData = (LPRGNDATA)LoadResource(GetModuleHandle(0), hrSkin);
	if (!pData) return FALSE;

	// create region from binary data
	HRGN hRegion = ExtCreateRegion(NULL, SizeofResource(NULL,hrSkin), pData);

	// set region
	SetWindowRgn( this->hwnd, hRegion, FALSE );

	return TRUE;
}


