// :: Part of RegionCreator
// Author: Sunshine

#pragma once
#include <windows.h>
#include "CImageFile.h"


void InitImageBox(void);
HWND CreateImageBox(HWND hwndParent, int x, int y);


class ImageBox

{
public:
    ImageBox(HWND hwndParent);
    ~ImageBox();

	// window procedure
    static LRESULT CALLBACK WndProc(
       HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);

	LRESULT OnPaint       (WPARAM wParam, LPARAM lParam);
	LRESULT OnCreate	  (WPARAM wParam, LPARAM lParam);
	LRESULT OnVScroll	  (WPARAM wParam, LPARAM lParam);
	LRESULT OnHScroll	  (WPARAM wParam, LPARAM lParam);

	LRESULT OnMouseMove	  (WPARAM wParam, LPARAM lParam);
	LRESULT OnLeftButDown (WPARAM wParam, LPARAM lParam);
	LRESULT OnLeftButUp	  (WPARAM wParam, LPARAM lParam);
	LRESULT OnERASEBKGND  (WPARAM wParam, LPARAM lParam);

	bool setImage(CImageFile* ImageFile);
	bool setZoom(float fZoom);

	//void ShowScrollBars(bool enabled);

private:

    HWND     hwnd;         // The control's window handle
	bool	 bImageLoaded; // is an image alreay loaded?
	CImageFile*	image;
	bool	 bImageIsSmaller; // Image is smaller than imagebox

	// scrollbar stuff
	HWND	hHScroll;
	HWND	hVScroll;
	int		iVertScrollPos;		// position of vertical scrollbar
	int		iHorzScrollPos;		// position of horizontal scrollbar

	// mouse stuff
	int		iMouseDownX, iMouseDownY;
	bool	bMouseDown;

	// zoom factor
	float	fZoom;

};

ImageBox * GetImageBoxCtrl(HWND hwnd);